# This file was created automatically by SWIG.
import materialc
from SWIG.common.pixelattribute import PxlAttributeRegistrationPtr
from SWIG.common.IO.stringimage import StringImagePtr
from SWIG.common.timestamp import TimeStampPtr;
class MaterialPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,materialc=materialc):
        if self.thisown == 1 :
            materialc.delete_Material(self)
    def name(self, *_args, **_kwargs):
        val = apply(materialc.Material_name,(self,) + _args, _kwargs)
        return val
    def add1Property(self, *_args, **_kwargs):
        val = apply(materialc.Material_add1Property,(self,) + _args, _kwargs)
        return val
    def remove1Property(self, *_args, **_kwargs):
        val = apply(materialc.Material_remove1Property,(self,) + _args, _kwargs)
        return val
    def fetchProperty(self, *_args, **_kwargs):
        val = apply(materialc.Material_fetchProperty,(self,) + _args, _kwargs)
        return val
    def getProperty(self, *_args, **_kwargs):
        val = apply(materialc.Material_getProperty,(self,) + _args, _kwargs)
        return val
    def nProperties(self, *_args, **_kwargs):
        val = apply(materialc.Material_nProperties,(self,) + _args, _kwargs)
        return val
    def clear_xref(self, *_args, **_kwargs):
        val = apply(materialc.Material_clear_xref,(self,) + _args, _kwargs)
        return val
    def cross_reference(self, *_args, **_kwargs):
        val = apply(materialc.Material_cross_reference,(self,) + _args, _kwargs)
        return val
    def self_consistent(self, *_args, **_kwargs):
        val = apply(materialc.Material_self_consistent,(self,) + _args, _kwargs)
        return val
    def precompute(self, *_args, **_kwargs):
        val = apply(materialc.Material_precompute,(self,) + _args, _kwargs)
        return val
    def consistency_messages(self, *_args, **_kwargs):
        val = apply(materialc.Material_consistency_messages,(self,) + _args, _kwargs)
        return val
    def contributes_to_flux(self, *_args, **_kwargs):
        val = apply(materialc.Material_contributes_to_flux,(self,) + _args, _kwargs)
        return val
    def cleanAttributes(self, *_args, **_kwargs):
        val = apply(materialc.Material_cleanAttributes,(self,) + _args, _kwargs)
        return val
    def assignToPixels(self, *_args, **_kwargs):
        val = apply(materialc.Material_assignToPixels,(self,) + _args, _kwargs)
        return val
    def assignToPixelGroup(self, *_args, **_kwargs):
        val = apply(materialc.Material_assignToPixelGroup,(self,) + _args, _kwargs)
        return val
    def assignToAllPixels(self, *_args, **_kwargs):
        val = apply(materialc.Material_assignToAllPixels,(self,) + _args, _kwargs)
        return val
    def nPixelsInMicrostructure(self, *_args, **_kwargs):
        val = apply(materialc.Material_nPixelsInMicrostructure,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C Material instance at %s>" % (self.this,)
class Material(MaterialPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(materialc.new_Material,_args,_kwargs)
        self.thisown = 1




class MaterialAttributeRegistrationPtr(PxlAttributeRegistrationPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C MaterialAttributeRegistration instance at %s>" % (self.this,)
class MaterialAttributeRegistration(MaterialAttributeRegistrationPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(materialc.new_MaterialAttributeRegistration,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------

getMaterials = materialc.getMaterials

def getMaterialFromCategory(*_args, **_kwargs):
    val = apply(materialc.getMaterialFromCategory,_args,_kwargs)
    if val: val = MaterialPtr(val)
    return val

def getMaterialFromPoint(*_args, **_kwargs):
    val = apply(materialc.getMaterialFromPoint,_args,_kwargs)
    if val: val = MaterialPtr(val)
    return val

removeMaterialFromPixels = materialc.removeMaterialFromPixels

removeAllMaterials = materialc.removeAllMaterials

def getMaterialTimeStamp(*_args, **_kwargs):
    val = apply(materialc.getMaterialTimeStamp,_args,_kwargs)
    if val: val = TimeStampPtr(val); val.thisown = 1
    return val

def getMaterialImage(*_args, **_kwargs):
    val = apply(materialc.getMaterialImage,_args,_kwargs)
    if val: val = StringImagePtr(val); val.thisown = 1
    return val



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: material_.py,v $
# $Revision: 1.30 $
# $Author: langer $
# $Date: 2004/07/27 21:36:56 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from SWIG.common import switchboard
from common import debug
from common.IO import oofmenu
import string, copy

# Set of all materials
material_library = {}

def newCMaterial(name, *properties):
    try:
        material = material_library[name]
    except KeyError:
        material = Material(name)
    else:
        # Material already existed. Remove all of its properties.
        for property in material.properties():
            material.removeProperty(property)

    # Assign properties.
    for prop in properties:
        material.addProperty(prop)

    return material

#
# Extensions to the SWIG'd class:

def _Material___init__(self, name):
    self.this = materialc.new_Material(name)
    self.thisown = 1
    material_library[name] = self
    self.sbcallback = switchboard.requestCallback("property changed",
                                                  self.propChanged)
    # addProperty and removeProperty maintain a Python list of
    # property instances, which ensures that there exists a Python
    # reference to each property in a material.  Reference-count
    # manipulations are not required in the C++ code.
    self.proplist = []

Material.__init__ = _Material___init__

_old__del__ = Material.__del__
def _Material___del__(self):
    switchboard.removeCallback(self.sbcallback)
    _old__del__(self)

Material.__del__ = _Material___del__

def _Material_addProperty(self, prop):
    self.add1Property(prop)
    self.proplist.append(prop)
    self.cross_reference()

Material.addProperty = _Material_addProperty
    
def _Material_removeProperty_(self, *properties):
    for prop in properties:
        # Exception thrown by C++ code if the property is not present.
        self.remove1Property(prop)  # remove from C++ list
        self.proplist.remove(prop)
    self.cross_reference()

Material.removeProperty = _Material_removeProperty_

def _Material_properties(self):
    return [self.getProperty(i) for i in range(self.nProperties())]

MaterialPtr.properties = _Material_properties

def _Material_propChanged(self, propname):
    for prop in self.proplist:
        if prop.name() == propname:
            switchboard.notify("material changed", self.name())
            return
MaterialPtr.propChanged = _Material_propChanged

######

# A Material's identity is tied to its name.  Python object identity
# doesn't work, because the same Material returned to Python via SWIG
# gets wrapped in different objects each time it's returned.

def _Material__eq__(self, other):
    return isinstance(other, MaterialPtr) and other.name() == self.name()
MaterialPtr.__eq__ = _Material__eq__

def _Material__hash__(self):
    return hash(self.name())
MaterialPtr.__hash__ = _Material__hash__

######

def _Material___repr_(self):
    out = ["Material('" + self.name() + "'"]
    for prop in self.properties():
        out.append(`prop`)
    out = string.join(out, ",\n\t")
    return out + ")"

MaterialPtr.__repr__ = _Material___repr_

def _Material_copy_(self, newname):
    args = [newname] +  [copy.deepcopy(p) for p in self.properties()]
    m = apply(newCMaterial, args)
    return m

MaterialPtr.copy = _Material_copy_

##############################

# Create the singleton material attribute registration object.
# The (swig'd) constructor adds it to the global list of attributes.
attributeReg = MaterialAttributeRegistration()

###################

_old_getMaterials = getMaterials
def getMaterials(microstructure):
    return map(MaterialPtr, _old_getMaterials(microstructure))

