# This file was created automatically by SWIG.
import preconditionerc
class PreconditionerWrapPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C PreconditionerWrap instance at %s>" % (self.this,)
class PreconditionerWrap(PreconditionerWrapPtr):
    def __init__(self,this):
        self.this = this




class UnitPreconditionerWrapPtr(PreconditionerWrapPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C UnitPreconditionerWrap instance at %s>" % (self.this,)
class UnitPreconditionerWrap(UnitPreconditionerWrapPtr):
    def __init__(self,this):
        self.this = this




class ILUPreconditionerPtr(UnitPreconditionerWrapPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_ILUPreconditioner(self)
    def __repr__(self):
        return "<C ILUPreconditioner instance at %s>" % (self.this,)
class ILUPreconditioner(ILUPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_ILUPreconditioner,_args,_kwargs)
        self.thisown = 1




class ICPreconditionerPtr(UnitPreconditionerWrapPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_ICPreconditioner(self)
    def __repr__(self):
        return "<C ICPreconditioner instance at %s>" % (self.this,)
class ICPreconditioner(ICPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_ICPreconditioner,_args,_kwargs)
        self.thisown = 1




class UnPreconditionerPtr(UnitPreconditionerWrapPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_UnPreconditioner(self)
    def __repr__(self):
        return "<C UnPreconditioner instance at %s>" % (self.this,)
class UnPreconditioner(UnPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_UnPreconditioner,_args,_kwargs)
        self.thisown = 1




class JacobiPreconditionerPtr(UnitPreconditionerWrapPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_JacobiPreconditioner(self)
    def __repr__(self):
        return "<C JacobiPreconditioner instance at %s>" % (self.this,)
class JacobiPreconditioner(JacobiPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_JacobiPreconditioner,_args,_kwargs)
        self.thisown = 1




class BlockPreconditionerPtr(PreconditionerWrapPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_BlockPreconditioner(self)
    def __repr__(self):
        return "<C BlockPreconditioner instance at %s>" % (self.this,)
class BlockPreconditioner(BlockPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_BlockPreconditioner,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: preconditioner_.py,v $
# $Revision: 1.14 $
# $Author: redwing $
# $Date: 2004/09/10 18:01:41 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from common import cregisteredclass
from common.IO import parameter
from types import *

cregisteredclass.registerCClass(PreconditionerWrapPtr)

cregisteredclass.registerCClass(UnitPreconditionerWrapPtr)

# Special registration that registers the indicated class as both a
# Preconditioner and a UnitPreconditioner.
class UnitPreconditionerRegistration(cregisteredclass.Registration):
    def __init__(self, name, subclass, ordering,
                 params=[], secret=0, **kwargs):
        cregisteredclass.Registration.__init__(
            self, name, (PreconditionerWrapPtr, UnitPreconditionerWrapPtr),
            subclass, ordering, params, secret, **kwargs)

UnitPreconditionerRegistration(
    "ILU",
    ILUPreconditioner,
    ordering=100,
    tip="Incomplete LU-factorization",
    params=[])

UnitPreconditionerRegistration(
    "IC",
    ICPreconditioner,
    ordering=200,
    params=[],
    tip="Incomplete Cholesky preconditioner is appropriate only for microstructures with symmetric, positive definite stiffness matrices")

UnitPreconditionerRegistration(
    "Null",
    UnPreconditioner,
    ordering=300,
    params=[],
    tip="Be bold (or foolhardy) and attempt to solve the mesh without preconditioner")

UnitPreconditionerRegistration(
    "Jacobi",
    JacobiPreconditioner,
    ordering=500,
    params=[],
    tip="Jacobi preconditioner is the inverse of the diagonal part of the matrix, and is inexpensive to build.")


# Block preconditioner is composite, so it uses the ordinary
# registration process.
cregisteredclass.Registration(
    "Block",
    PreconditionerWrapPtr,
    BlockPreconditioner,
    ordering=1,
    params=[parameter.Parameter("inplane", UnitPreconditionerWrapPtr)],
    tip="An experimental preconditioner that knows about the structure of the finite element matrix.")
