# This file was created automatically by SWIG.
import heatconductivityc
from SWIG.engine.properties import PropertyPtr
from SWIG.engine.symmmatrix import SymmMatrixPtr
class IsoHeatConductivityPropPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def kappa(self, *_args, **_kwargs):
        val = apply(heatconductivityc.IsoHeatConductivityProp_kappa,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C IsoHeatConductivityProp instance at %s>" % (self.this,)
class IsoHeatConductivityProp(IsoHeatConductivityPropPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(heatconductivityc.new_IsoHeatConductivityProp,_args,_kwargs)
        self.thisown = 1




class AnisoHeatConductivityPropPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def kappa(self, *_args, **_kwargs):
        val = apply(heatconductivityc.AnisoHeatConductivityProp_kappa,(self,) + _args, _kwargs)
        if val: val = SymmMatrix3Ptr(val) 
        return val
    def __repr__(self):
        return "<C AnisoHeatConductivityProp instance at %s>" % (self.this,)
class AnisoHeatConductivityProp(AnisoHeatConductivityPropPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(heatconductivityc.new_AnisoHeatConductivityProp,_args,_kwargs)
        self.thisown = 1




class HeatSourcePropPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def qdot(self, *_args, **_kwargs):
        val = apply(heatconductivityc.HeatSourceProp_qdot,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C HeatSourceProp instance at %s>" % (self.this,)
class HeatSourceProp(HeatSourcePropPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(heatconductivityc.new_HeatSourceProp,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: heatconductivity_.py,v $
# $Revision: 1.17 $
# $Author: redwing $
# $Date: 2004/09/20 19:53:57 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


from common import utils
from common.IO import parameter
from engine import problem
from engine import propertyregistration
from SWIG.engine import symmmatrix

PropertyRegistration = propertyregistration.PropertyRegistration

PropertyRegistration(
    'Thermal:Conductivity:IsoHeatConductivity', IsoHeatConductivityProp,
    "SWIG.engine.property.heatconductivity.heatconductivity",98,
    [parameter.FloatParameter('kappa',1.0)],
    fields=[problem.Temperature], fluxes=[problem.Heat_Flux],
    propertyType="HeatConductivity"
    )

# Reprs refer to the registered name, not the actual class name,
# because properties are instanced via the registry.
def _IsoHeatConductivityProp___repr__(self):
    return "IsoHeatConductivity(name='%s', kappa=%s)" % \
           (self.name(), `self.kappa()` )

IsoHeatConductivityPropPtr.__repr__ = _IsoHeatConductivityProp___repr__



PropertyRegistration(
    'Thermal:Conductivity:AnisoHeatConductivity', AnisoHeatConductivityProp,
    "SWIG.engine.property.heatconductivity.heatconductivity",99,
    [symmmatrix.SymmMatrix3Parameter(
    'kappa',
    symmmatrix.SymmMatrix3(xx=1.0, yy=1.0, zz=1.0))],
    fields=[problem.Temperature], fluxes=[problem.Heat_Flux],
    propertyType="HeatConductivity")


def _AnisoHeatConductivity___repr__(self):
    return "AnisoHeatConductivity(name='%s', kappa=%s)" % \
           (self.name(), `self.kappa()`)

AnisoHeatConductivityPropPtr.__repr__ = _AnisoHeatConductivity___repr__


PropertyRegistration(
    'Thermal:HeatSource', HeatSourceProp,
    "SWIG.engine.property.heatconductivity.heatconductivity",100,
    [parameter.FloatParameter('rate', 0.0)],
    fluxes=[problem.Heat_Flux],
    propertyType="HeatSource"
    )

def _HeatSource___repr__(self):
    return "HeatSource(name='%s', rate=%s)" % (self.name(), `self.qdot()`)

HeatSourcePropPtr.__repr__ = _HeatSource___repr__

from SWIG.engine.properties import PropertyPtr
