# This file was created automatically by SWIG.
import solverc
class SolverPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C Solver instance at %s>" % (self.this,)
class Solver(SolverPtr):
    def __init__(self,this):
        self.this = this




class GMRESSolverPtr(SolverPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,solverc=solverc):
        if self.thisown == 1 :
            solverc.delete_GMRESSolver(self)
    def message(self, *_args, **_kwargs):
        val = apply(solverc.GMRESSolver_message,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C GMRESSolver instance at %s>" % (self.this,)
class GMRESSolver(GMRESSolverPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(solverc.new_GMRESSolver,_args,_kwargs)
        self.thisown = 1




class BiCGSolverPtr(SolverPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,solverc=solverc):
        if self.thisown == 1 :
            solverc.delete_BiCGSolver(self)
    def message(self, *_args, **_kwargs):
        val = apply(solverc.BiCGSolver_message,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C BiCGSolver instance at %s>" % (self.this,)
class BiCGSolver(BiCGSolverPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(solverc.new_BiCGSolver,_args,_kwargs)
        self.thisown = 1




class CGSolverPtr(SolverPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,solverc=solverc):
        if self.thisown == 1 :
            solverc.delete_CGSolver(self)
    def message(self, *_args, **_kwargs):
        val = apply(solverc.CGSolver_message,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C CGSolver instance at %s>" % (self.this,)
class CGSolver(CGSolverPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(solverc.new_CGSolver,_args,_kwargs)
        self.thisown = 1




class BiCGStabSolverPtr(SolverPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,solverc=solverc):
        if self.thisown == 1 :
            solverc.delete_BiCGStabSolver(self)
    def message(self, *_args, **_kwargs):
        val = apply(solverc.BiCGStabSolver_message,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C BiCGStabSolver instance at %s>" % (self.this,)
class BiCGStabSolver(BiCGStabSolverPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(solverc.new_BiCGStabSolver,_args,_kwargs)
        self.thisown = 1




class DirectSolverPtr(SolverPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,solverc=solverc):
        if self.thisown == 1 :
            solverc.delete_DirectSolver(self)
    def message(self, *_args, **_kwargs):
        val = apply(solverc.DirectSolver_message,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C DirectSolver instance at %s>" % (self.this,)
class DirectSolver(DirectSolverPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(solverc.new_DirectSolver,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: solver_.py,v $
# $Revision: 1.16 $
# $Author: redwing $
# $Date: 2004/09/09 18:01:02 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from common import cregisteredclass
from common import debug
from common.IO import parameter
import SWIG.engine.preconditioner



def _apply(self, meshcontext):
    from SWIG.engine import solverstepper
    equilibrate = solverstepper.SolverStepper(
        self, meshcontext, solverstepper.SolverStepperIterationManager(1))
    equilibrate.precompute()
    equilibrate.iterate()
    equilibrate.short_postcompute()

    


SolverPtr.apply = _apply



cregisteredclass.registerCClass(SolverPtr)


cregisteredclass.Registration("GMRES", SolverPtr, GMRESSolver, ordering=100,
                              params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.IntParameter("krylov_dimension", 100),
    parameter.FloatParameter("tolerance", 1.e-8),
    parameter.Parameter("pc", SWIG.engine.preconditioner.PreconditionerWrapPtr)
    ]
                              )

cregisteredclass.Registration("BiCG", SolverPtr, BiCGSolver, ordering=200,
                              params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1.e-8),
    parameter.Parameter("pc", SWIG.engine.preconditioner.PreconditionerWrapPtr)
    ]
                              )

cregisteredclass.Registration("CG", SolverPtr, CGSolver, ordering=300,
                              params=[
    parameter.IntParameter("max_iterations",  1000),
    parameter.FloatParameter("tolerance", 1.e-8),
    parameter.Parameter("pc", SWIG.engine.preconditioner.PreconditionerWrapPtr)
    ]
                              )

cregisteredclass.Registration("BiCGStab", SolverPtr, BiCGStabSolver, ordering=400,
                              params=[
    parameter.IntParameter("max_iterations",  1000),
    parameter.FloatParameter("tolerance", 1.e-8),
    parameter.Parameter("pc", SWIG.engine.preconditioner.PreconditionerWrapPtr)
    ]
                              )

cregisteredclass.Registration("Direct", SolverPtr, DirectSolver,
                              ordering=1000, params=[] )


from SWIG.engine.preconditioner import PreconditionerWrapPtr




