// -*- C++ -*-
// $RCSfile: hysteresis.C,v $
// $Revision: 1.3 $
// $Author: ericma $
// $Date: 2004/09/16 21:38:37 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modifed
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#include "image/oofimage.h"
#include "common/doublearray.h"
#include "common/boolarray.h"

BoolArray hysteresisThresh(const DoubleArray& image, double T1, double T2)
{
  BoolArray newimage(image.width(),image.height());

  for (DoubleArray::const_iterator i = image.begin(); i != image.end(); ++i) {
    if (image[i]>=T2)
      newimage[i.coord()] = 1;
  }
  
  int xChange[8]= {-1,0,1,1,1,0,-1,-1}, yChange[8]={1,1,1,0,-1,-1,-1,0};

  bool changed=1;
  while(changed) {
    changed=0;
    for (DoubleArray::const_iterator i = image.begin(); i != image.end(); ++i) {
      if(!newimage[i.coord()] && image[i]>=T1) {
	int x=i.coord()(0), y=i.coord()(1);
      	for(int dir=0;dir<8;dir++) {
	  int newX=x+xChange[dir], newY=y+yChange[dir];
	  if(newX>=0 && newX<image.width() && newY>=0 && newY<image.height() 
	     && newimage[ICoord(newX,newY)]) {
	    newimage[i.coord()]=1;
	    changed=1;
	    break;
	  }
	}
      }
    }
  }

  return newimage;
}
